/*
 * CenterKnnGPU.cpp
 *
 * CenterKnnGPU class methods file
 *
 *      Author: Pablo David Gutiérrez
 *      Author: Miguel Lastra
 *      Author: Jaume Barcardit
 *      Author: José Manuel Benítez
 *      Author: Francisco Herrera
 */

#include "CenterKnnGPU.h"

CenterKnnGPU::CenterKnnGPU(DatasetGPU* train, DatasetGPU* tst) : KnnGPU(train,tst){
	// TODO Auto-generated constructor stub

}

CenterKnnGPU::~CenterKnnGPU() {
	// TODO Auto-generated destructor stub
}


void CenterKnnGPU::ComputeDistanceGPU(int trainChunk, int testChunk){
	int nthreads = THREADSMULT;
	int block = TESTCHUNK;
	int shared = training->getNVariables()*sizeof(float);

	distanceCenterKernel<<<block, nthreads, shared, kernelStream>>>(deviceTraining->getDevicePointer(), deviceTest->getDevicePointer(), training->getNVariables(), trainingSize, testSize, deviceDistanceMatrix, trainChunk, trainingChunks, training->getNNumeric(), k, training->getNOutput());
}

void CenterKnnGPU::inizalization(){
	DatasetCenter* tr = (DatasetCenter*)training;
	tr->computeCenters(); // Computing centers
	string constant = "deviceCenters";
	cudaMemcpyToSymbol(constant.c_str(), tr->getCenters(), sizeof(float) * tr->getNVariables() * tr->getNOutput()); //Copying centers to constant memory
}
