/*
 * CenterKnnGPU.h
 *
 * CenterKnnGPU class header
 *
 *      Author: Pablo David Gutiérrez
 *      Author: Miguel Lastra
 *      Author: Jaume Barcardit
 *      Author: José Manuel Benítez
 *      Author: Francisco Herrera
 */

#ifndef CENTERKNNGPU_H_
#define CENTERKNNGPU_H_

#include "KnnGPU.h"
#include "DatasetCenter.h"

/* CenterKnnGPU class inherits from KnnGPU class, it only modifies the initialize method and the distance computation */
class CenterKnnGPU: public KnnGPU {
public:
	/* Class constructor */
	CenterKnnGPU(DatasetGPU* train, DatasetGPU* tst);
	/* Class destructor */
	virtual ~CenterKnnGPU();

	/* Initialization method, computes and copies the center values of each class to constant memory */
	virtual void inizalization();

	/* Center kNN distance kernel wrapper function */
	virtual void ComputeDistanceGPU(int trainChunk, int testChunk);
};

#endif /* CENTERKNNGPU_H_ */
