/*
 * CudaSelection.h
 *
 * Quicksort-based selection kernel headers
 *
 *      Author: Pablo David Gutiérrez
 *      Author: Miguel Lastra
 *      Author: Jaume Barcardit
 *      Author: José Manuel Benítez
 *      Author: Francisco Herrera
 */

#ifndef CUDASELECTION_H_
#define CUDASELECTION_H_

#include <cstdio>
#include "const.h"

/* Performs the quicksort-based selection on a chunk of the distance matrix */
__global__ void quickSelection(float* globalRows, int trainingSize, int testSize, int trainChunks, int trainChunk, int testChunk, unsigned long int* returnPossitions, float* returnValues, int selections, float* quickRows, unsigned long int* quickActualIndex, unsigned long int* quickNextIndex, float* quickRowsRight, unsigned long int* quickIndexRight);
/* Performs the quicksort-based selection proposed by Komarov on a chunk of the distance matrix */
__global__ void quickKomarov(float* globalRows, int trainingSize, int testSize, int trainChunks, int trainChunk, int testChunk, unsigned long int* returnPossitions, float* returnValues, int selections, float* quickRows, unsigned long int* quickActualIndex, unsigned long int* quickNextIndex, float* quickRowsRight, unsigned long int* quickIndexRight);

#endif /* CUDASELECTION_H_ */
