/*
 * DatasetCenter.cpp
 *
 * DatasetCenter class methods file
 *
 *      Author: Pablo David Gutiérrez
 *      Author: Miguel Lastra
 *      Author: Jaume Barcardit
 *      Author: José Manuel Benítez
 *      Author: Francisco Herrera
 */

#include "DatasetCenter.h"

DatasetCenter::DatasetCenter() {
	// TODO Auto-generated constructor stub
	centers = 0;
}

DatasetCenter::~DatasetCenter() {
	// TODO Auto-generated destructor stub
}

void DatasetCenter::allocate(){
	DatasetGPU::allocate();
	centers = new float[(nVariables-1)*nOutput];
}


void DatasetCenter::computeCenters(){
	unsigned long int *total = new unsigned long int[nOutput];

	/* Computes the average attribute value of each class */
	for(unsigned long int i = 0; i < nInst; i++){
		int cn = getClassNumber(i);
		total[cn]++;
		for(int j = 0; j < nVariables-1; j++)
			centers[nOutput*j+cn] += getValue(i,j);
	}
	for(unsigned long int i = 0; i < (nVariables-1)*nOutput; i++){
		centers[i] /= (total[i%nOutput]*1.0);
	}
	delete[] total;
}
