/*
 * DatasetCenter.h
 *
 * DatasetCenter class header
 *
 *      Author: Pablo David Gutiérrez
 *      Author: Miguel Lastra
 *      Author: Jaume Barcardit
 *      Author: José Manuel Benítez
 *      Author: Francisco Herrera
 */

#ifndef DATASETCENTER_H_
#define DATASETCENTER_H_

#include "DatasetGPU.h"

/* DatasetCenter class inherits from DatasetGPU class adding structures and functions to compute the center of each class of the dataset */
class DatasetCenter: public DatasetGPU {
private:
	/* Array to store the centers of the classes */
	float* centers;
public:
	/* Default constructor */
	DatasetCenter();
	/* Destructor */
	virtual ~DatasetCenter();

	/* CPU data allocation function overridden*/
	virtual void allocate();
	/* Computes the center of each class */
	void computeCenters();

	/* Returns the centers pointer */
	inline float* getCenters() { return centers; }
};

#endif /* DATASETCENTER_H_ */
