/*
 * KNNAdaptiveGPU.h
 *
 * KNNAdaptiveGPU class header
 *
 *      Author: Pablo David Gutiérrez
 *      Author: Miguel Lastra
 *      Author: Jaume Barcardit
 *      Author: José Manuel Benítez
 *      Author: Francisco Herrera
 */

#ifndef KNNADAPTATIVE_H_
#define KNNADAPTATIVE_H_

#include "KnnGPU.h"
#include "DatasetAdaptive.h"


/* KNNAdaptiveGPU class inherits from KnnGPU class adding overriding some functions to use the radius previously computed */
class KNNAdaptiveGPU: public KnnGPU {
public:
	/* Constructor */
	KNNAdaptiveGPU(DatasetGPU* train, DatasetGPU* tst);
	/* Destructor */
	virtual ~KNNAdaptiveGPU();

	/* Computes a distance matrix chunk using the kNN adaptive rule*/
	virtual void ComputeDistanceGPU(int trainChunk, int testChunk);
	/* The kNN adaptive rule computes the square root in all distances
	 * This function is overridden to copy the results
	 */
	virtual void ComputeSqrtGPU();

	/* Initializes the algorithm computing the radius for the training set*/
	virtual void initialize();
};

#endif /* KNNADAPTATIVE_H_ */
