#include "KnnKomarov.h"
#include "CudaSelection.h"

KnnKomarov::KnnKomarov(DatasetGPU* train, DatasetGPU* tst) : KnnGPU(train, tst){}

void KnnKomarov::ComputeSelectionGPU(int trainChunk, int testChunk){

	/* Komarov's Quick sort selection */
	dim3 blockSize;
	blockSize.x = 512;
	blockSize.y = 1;
	int nblocks = TESTCHUNK;
	cudaDeviceSynchronize();
	int totalThreads = blockSize.x*blockSize.y;
	int shared = (sizeof(float)+sizeof(unsigned long int))*totalThreads;
	quickKomarov<<<nblocks,blockSize,shared,kernelStream>>>(deviceDistanceMatrix, trainingSize, testSize, trainingChunks, trainChunk, testChunk, deviceNeighborIndexFirstStep, deviceNeighborValuesFirstStep, k, deviceDistanceLeftSelection, deviceNeighborActualIndexSelection, deviceNeighborLeftIndexSelection, deviceDistanceRightSelection, deviceNeighborRightIndexSelection);
	cudaDeviceSynchronize();
}
