/*
 * util.h
 *
 * Utility functions file
 *
 *      Author: Pablo David Gutiérrez
 *      Author: Miguel Lastra
 *      Author: Jaume Barcardit
 *      Author: José Manuel Benítez
 *      Author: Francisco Herrera
 */

#ifndef UTIL_H_
#define UTIL_H_

#include <cstdlib>
#include <ctime>
#include <iostream>

/** returns a float between 0 and 1*/
inline float randf(){ return (float)rand()/(float)RAND_MAX;}

/** returns a float between top and low*/
inline float randf(float top, float low){ return ((float)rand()/(float)RAND_MAX) * (top - low) + low;}

/** returns a int between 0 and limit - 1*/
inline int rand(int limit){ return rand() % limit;}

/** returns a int between low and top*/
inline int rand(int low, int top){ return (rand() % (top - low)) + low;}

/** Returns the time difference between start and end times */
inline timespec diff(timespec start, timespec end){
	timespec temp;
	if ((end.tv_nsec-start.tv_nsec)<0) {
		temp.tv_sec = end.tv_sec-start.tv_sec-1;
		temp.tv_nsec = 1000000000+end.tv_nsec-start.tv_nsec;
	} else {
		temp.tv_sec = end.tv_sec-start.tv_sec;
		temp.tv_nsec = end.tv_nsec-start.tv_nsec;
	}
	return temp;
}




#endif /* UTIL_H_ */
